// © ANO PO "KSI", 2016

#include "DBParamWindow.h"

DBParamWindow::DBParamWindow(QWidget *parent)
	: QDialog(parent),
	m_pSettings(nullptr)
{
	m_dirWidget = new ChooseDirWidget(tr("Source directory"));
	m_dbfileWidget = new ChooseDirWidget(tr("Checksums file"));
	m_dbfileWidget->setExtFilter(tr("All files (*);;SHA256 (*.sha256)"), tr("SHA256 (*.sha256)"));
	m_dbfileWidget->setDirMode(false);

	QPushButton* pButtonOk = new QPushButton(style()->standardIcon(QStyle::SP_DialogOkButton),tr("Ok"));
	QPushButton* pButtonCancel = new QPushButton(style()->standardIcon(QStyle::SP_DialogCancelButton),tr("Cancel"));

	QBoxLayout* pCmdLayout = new QHBoxLayout;
	pCmdLayout->addStretch(0);
	pCmdLayout->addWidget(pButtonOk);
	pCmdLayout->addWidget(pButtonCancel);
	pCmdLayout->addStretch(0);

	QBoxLayout* pMainLayout = new QVBoxLayout;
	pMainLayout->addWidget(m_dirWidget);
	pMainLayout->addWidget(m_dbfileWidget);
	pMainLayout->addLayout(pCmdLayout);
	pMainLayout->addStretch(0);

	setLayout(pMainLayout);

	connect(pButtonOk, &QPushButton::clicked, this, &DBParamWindow::accept);
	connect(pButtonCancel, &QPushButton::clicked, this, &DBParamWindow::reject);
}

DBParamWindow::~DBParamWindow()
{

}

void DBParamWindow::accept()
{
	auto s = settings();

	if (s) {
		s->setValue("SourceDirectory", m_dirWidget->value());
		s->setValue("ChecksumFile", m_dbfileWidget->value());
	}

	QDialog::accept();
}

void DBParamWindow::reject()
{
	QDialog::reject();
}

int DBParamWindow::exec()
{
	auto s = settings();

	if (s) {
		m_dirWidget->setValue(s->value("SourceDirectory").toString());
		m_dbfileWidget->setValue(s->value("ChecksumFile").toString());
	}

	return QDialog::exec();
}
